"""added tenant id for guardrail tables and admin audit

Revision ID: 3e84bb67bced
Revises: 2d992e5994c8
Create Date: 2025-04-09 18:15:00.962745

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa
import core.db_models.utils


# revision identifiers, used by Alembic.
revision: str = '3e84bb67bced'
down_revision: Union[str, None] = '2d992e5994c8'
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None
tables = ['guardrail', 'guardrail_version_history', 'response_template', 'admin_audits']


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    # Adding tenant_id column to guardrail tables by executing queries instead of using op.add_column
    # because it doesn't add columns with default values and NOT NULL together
    connection = op.get_bind()
    for table in tables:
        connection.execute(
            sa.text(f"ALTER TABLE {table} ADD COLUMN tenant_id VARCHAR(255) NOT NULL DEFAULT 1")
        )
        op.create_index(f'ix_{table}_tenant_id', table, ['tenant_id'])
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    for table in tables:
        op.drop_index(f'ix_{table}_tenant_id', table_name=table)
        op.drop_column(table, 'tenant_id')
    # ### end Alembic commands ###
